diff --git a/.gitignore b/.gitignore
index eb1260c..e33079c 100755
--- a/.gitignore
+++ b/.gitignore
@@ -83,3 +83,10 @@ cscope.*
 
 # spl ais files
 /spl/*.ais
+
+# xbuild
+xbuild*
+
+# generated binaries
+u-boot-a38x-GrandTeton*
+monext
diff --git a/board/mv_ebu/a38x/mv_main_a38x.c b/board/mv_ebu/a38x/mv_main_a38x.c
index 88d00b6..64cfba4 100755
--- a/board/mv_ebu/a38x/mv_main_a38x.c
+++ b/board/mv_ebu/a38x/mv_main_a38x.c
@@ -34,6 +34,7 @@
 *******************************************************************************/
 
 #include <common.h>
+#include <environment.h>
 #include "mvTypes.h"
 #include "mvBoardEnvLib.h"
 #include "mvBoardEnvSpec.h"
@@ -687,7 +688,11 @@ void misc_init_r_env(void)
 #if 1	//ALPHA_CUSTOMIZE
 	/* Check push Reset button */ //Casper, 20150528, GrandTeton no usb button
 	// low active.
-	setenv("bootcmd","nand read.e 0xa00000 0x500000 0x500000;nand read.e 0xf00000 0xa00000 0x500000;bootm 0xa00000 0xf00000");
+	env = getenv("bootcmd");
+        if (!env) {
+		printf("bootcmd undefined, using default: 'nand read.e 0xa00000 0x500000 0x500000;nand read.e 0xf00000 0xa00000 0x500000;bootm 0xa00000 0xf00000'");
+		setenv("bootcmd","nand read.e 0xa00000 0x500000 0x500000;nand read.e 0xf00000 0xa00000 0x500000;bootm 0xa00000 0xf00000");
+	}
 #endif
   
 	env = getenv("standalone");
diff --git a/include/configs/armada_38x.h b/include/configs/armada_38x.h
index 1511afc..3a24a41 100755
--- a/include/configs/armada_38x.h
+++ b/include/configs/armada_38x.h
@@ -60,6 +60,7 @@
 #endif
 #ifdef CONFIG_ARMADA_39X
 	#define MV88F69XX
+
 #endif
 #define MV_SEC_64K
 #define MV_BOOTSIZE_512K
@@ -78,6 +79,8 @@
 
 #define MV_DDR_TRAINING_CMD_NEW_TIP
 
+#define CONFIG_CMD_SAVEENV
+
 /*
  * Debug
  */
@@ -372,7 +375,7 @@ extern unsigned int mvTclkGet(void);
 		#define MONITOR_HEADER_LEN              0x200
 		#define CONFIG_SYS_MONITOR_BASE         0
 		#define CONFIG_SYS_MONITOR_LEN          0x80000           /* Reserve 512 kB for Monitor */
-		#define CONFIG_ENV_RANGE                CONFIG_ENV_SIZE * 8
+		#define CONFIG_ENV_RANGE                CONFIG_ENV_SIZE * 2
 
 		#define MV_NBOOT_BASE                   0
 		#define MV_NBOOT_LEN                    (4 << 10)       /* Reserved 4KB for boot strap */
@@ -491,8 +494,8 @@ extern unsigned int mvTclkGet(void);
 	#define CONFIG_DOS_PARTITION
 	#define CONFIG_ISO_PARTITION
 	#define ENV_USB0_MODE   "host"
-#if 0 //ALPHA_CUSTOMIZE
-	#define ENV_USB_ACTIVE		  "1"
+#if 1 //ALPHA_CUSTOMIZE
+	#define ENV_USB_ACTIVE        "1"
 #else
 	#define ENV_USB_ACTIVE        "0"
 #endif
@@ -615,7 +618,7 @@ extern unsigned int mvTclkGet(void);
 #define PCI_HOST_AUTO    2              /* detected via arbiter enable  */
 
 #define CONFIG_UBOOT_SIZE                       0x100000
-#define CONFIG_SPARE_AREA			0x400000
+#define CONFIG_SPARE_AREA			0x000000
 
 /* NOR-FLASH stuff	*/
 /************************/
@@ -623,7 +626,7 @@ extern unsigned int mvTclkGet(void);
 #define CONFIG_ENV_SIZE_NOR			0x20000
 #define CONFIG_ENV_SECT_SIZE_NOR	0x20000
 #define CONFIG_ENV_OFFSET_NOR		0x100000	/* environment starts here  */
-#define CONFIG_ENV_RANGE_NOR 		CONFIG_ENV_SIZE_NOR * 8
+#define CONFIG_ENV_RANGE_NOR 		CONFIG_ENV_SIZE_NOR * 2
 #define CONFIG_ENV_ADDR_NOR			(NOR_CS_BASE + CONFIG_ENV_OFFSET_NOR)
 
 #if defined(MV_INCLUDE_NOR)
